/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2020 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
define(["./when-0488ac89","./Check-78ca6843","./Math-8a4c9da1","./Cartesian2-cc1e6450","./defineProperties-c6a70625","./Transforms-fa4f10bc","./RuntimeError-4d6e0952","./WebGLConstants-66e14a3b","./ComponentDatatype-9252f28f","./GeometryAttribute-3345e440","./GeometryAttributes-3227db5b","./IndexDatatype-8575c917","./IntersectionTests-12255a09","./Plane-466db411","./EllipsoidTangentPlane-70069c84","./EllipsoidRhumbLine-9e95354f","./PolygonPipeline-5e2e1765","./EllipsoidGeodesic-80f12c10","./PolylinePipeline-1e8e81a9","./WallGeometryLibrary-384458db"],function(w,e,G,L,i,x,t,a,T,V,D,I,n,r,o,s,l,m,d,S){"use strict";var R=new L.Cartesian3,M=new L.Cartesian3;function u(e){var i=(e=w.defaultValue(e,w.defaultValue.EMPTY_OBJECT)).positions,t=e.maximumHeights,a=e.minimumHeights,n=w.defaultValue(e.granularity,G.CesiumMath.RADIANS_PER_DEGREE),r=w.defaultValue(e.ellipsoid,L.Ellipsoid.WGS84);this._positions=i,this._minimumHeights=a,this._maximumHeights=t,this._granularity=n,this._ellipsoid=L.Ellipsoid.clone(r),this._workerName="createWallOutlineGeometry";var o=1+i.length*L.Cartesian3.packedLength+2;w.defined(a)&&(o+=a.length),w.defined(t)&&(o+=t.length),this.packedLength=o+L.Ellipsoid.packedLength+1}u.pack=function(e,i,t){var a;t=w.defaultValue(t,0);var n=e._positions,r=n.length;for(i[t++]=r,a=0;a<r;++a,t+=L.Cartesian3.packedLength)L.Cartesian3.pack(n[a],i,t);var o=e._minimumHeights;if(r=w.defined(o)?o.length:0,i[t++]=r,w.defined(o))for(a=0;a<r;++a)i[t++]=o[a];var s=e._maximumHeights;if(r=w.defined(s)?s.length:0,i[t++]=r,w.defined(s))for(a=0;a<r;++a)i[t++]=s[a];return L.Ellipsoid.pack(e._ellipsoid,i,t),i[t+=L.Ellipsoid.packedLength]=e._granularity,i};var p=L.Ellipsoid.clone(L.Ellipsoid.UNIT_SPHERE),f={positions:void 0,minimumHeights:void 0,maximumHeights:void 0,ellipsoid:p,granularity:void 0};return u.unpack=function(e,i,t){var a;i=w.defaultValue(i,0);var n,r,o=e[i++],s=new Array(o);for(a=0;a<o;++a,i+=L.Cartesian3.packedLength)s[a]=L.Cartesian3.unpack(e,i);if(0<(o=e[i++]))for(n=new Array(o),a=0;a<o;++a)n[a]=e[i++];if(0<(o=e[i++]))for(r=new Array(o),a=0;a<o;++a)r[a]=e[i++];var l=L.Ellipsoid.unpack(e,i,p),m=e[i+=L.Ellipsoid.packedLength];return w.defined(t)?(t._positions=s,t._minimumHeights=n,t._maximumHeights=r,t._ellipsoid=L.Ellipsoid.clone(l,t._ellipsoid),t._granularity=m,t):(f.positions=s,f.minimumHeights=n,f.maximumHeights=r,f.granularity=m,new u(f))},u.fromConstantHeights=function(e){var i,t,a=(e=w.defaultValue(e,w.defaultValue.EMPTY_OBJECT)).positions,n=e.minimumHeight,r=e.maximumHeight,o=w.defined(n),s=w.defined(r);if(o||s){var l=a.length;i=o?new Array(l):void 0,t=s?new Array(l):void 0;for(var m=0;m<l;++m)o&&(i[m]=n),s&&(t[m]=r)}return new u({positions:a,maximumHeights:t,minimumHeights:i,ellipsoid:e.ellipsoid})},u.createGeometry=function(e){var i=e._positions,t=e._minimumHeights,a=e._maximumHeights,n=e._granularity,r=e._ellipsoid,o=S.WallGeometryLibrary.computePositions(r,i,a,t,n,!1);if(w.defined(o)){var s,l=o.bottomPositions,m=o.topPositions,d=m.length,u=2*d,p=new Float64Array(u),f=0;for(d/=3,s=0;s<d;++s){var h=3*s,c=L.Cartesian3.fromArray(m,h,R),g=L.Cartesian3.fromArray(l,h,M);p[f++]=g.x,p[f++]=g.y,p[f++]=g.z,p[f++]=c.x,p[f++]=c.y,p[f++]=c.z}var y=new D.GeometryAttributes({position:new V.GeometryAttribute({componentDatatype:T.ComponentDatatype.DOUBLE,componentsPerAttribute:3,values:p})}),v=u/3;u=2*v-4+v;var E=I.IndexDatatype.createTypedArray(v,u),_=0;for(s=0;s<v-2;s+=2){var C=s,H=s+2,b=L.Cartesian3.fromArray(p,3*C,R),A=L.Cartesian3.fromArray(p,3*H,M);if(!L.Cartesian3.equalsEpsilon(b,A,G.CesiumMath.EPSILON10)){var P=s+1,k=s+3;E[_++]=P,E[_++]=C,E[_++]=P,E[_++]=k,E[_++]=C,E[_++]=H}}return E[_++]=v-2,E[_++]=v-1,new V.Geometry({attributes:y,indices:E,primitiveType:V.PrimitiveType.LINES,boundingSphere:new x.BoundingSphere.fromVertices(p)})}},function(e,i){return w.defined(i)&&(e=u.unpack(e,i)),e._ellipsoid=L.Ellipsoid.clone(e._ellipsoid),u.createGeometry(e)}});
