/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2020 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
define(["exports","./when-0488ac89","./Check-78ca6843","./Cartesian2-cc1e6450","./defineProperties-c6a70625","./Transforms-fa4f10bc","./WebGLConstants-66e14a3b"],function(e,a,t,v,n,M,r){"use strict";var i=a.freezeObject({NONE:0,TRIANGLES:1,LINES:2,POLYLINES:3});function O(e,t,n,r){this[0]=a.defaultValue(e,0),this[1]=a.defaultValue(n,0),this[2]=a.defaultValue(t,0),this[3]=a.defaultValue(r,0)}O.packedLength=4,O.pack=function(e,t,n){return n=a.defaultValue(n,0),t[n++]=e[0],t[n++]=e[1],t[n++]=e[2],t[n++]=e[3],t},O.unpack=function(e,t,n){return t=a.defaultValue(t,0),a.defined(n)||(n=new O),n[0]=e[t++],n[1]=e[t++],n[2]=e[t++],n[3]=e[t++],n},O.clone=function(e,t){if(a.defined(e))return a.defined(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t):new O(e[0],e[2],e[1],e[3])},O.fromArray=function(e,t,n){return t=a.defaultValue(t,0),a.defined(n)||(n=new O),n[0]=e[t],n[1]=e[t+1],n[2]=e[t+2],n[3]=e[t+3],n},O.fromColumnMajorArray=function(e,t){return O.clone(e,t)},O.fromRowMajorArray=function(e,t){return a.defined(t)?(t[0]=e[0],t[1]=e[2],t[2]=e[1],t[3]=e[3],t):new O(e[0],e[1],e[2],e[3])},O.fromScale=function(e,t){return a.defined(t)?(t[0]=e.x,t[1]=0,t[2]=0,t[3]=e.y,t):new O(e.x,0,0,e.y)},O.fromUniformScale=function(e,t){return a.defined(t)?(t[0]=e,t[1]=0,t[2]=0,t[3]=e,t):new O(e,0,0,e)},O.fromRotation=function(e,t){var n=Math.cos(e),r=Math.sin(e);return a.defined(t)?(t[0]=n,t[1]=r,t[2]=-r,t[3]=n,t):new O(n,-r,r,n)},O.toArray=function(e,t){return a.defined(t)?(t[0]=e[0],t[1]=e[1],t[2]=e[2],t[3]=e[3],t):[e[0],e[1],e[2],e[3]]},O.getElementIndex=function(e,t){return 2*e+t},O.getColumn=function(e,t,n){var r=2*t,a=e[r],i=e[1+r];return n.x=a,n.y=i,n},O.setColumn=function(e,t,n,r){var a=2*t;return(r=O.clone(e,r))[a]=n.x,r[1+a]=n.y,r},O.getRow=function(e,t,n){var r=e[t],a=e[t+2];return n.x=r,n.y=a,n},O.setRow=function(e,t,n,r){return(r=O.clone(e,r))[t]=n.x,r[t+2]=n.y,r};var u=new v.Cartesian2;O.getScale=function(e,t){return t.x=v.Cartesian2.magnitude(v.Cartesian2.fromElements(e[0],e[1],u)),t.y=v.Cartesian2.magnitude(v.Cartesian2.fromElements(e[2],e[3],u)),t};var o=new v.Cartesian2;O.getMaximumScale=function(e){return O.getScale(e,o),v.Cartesian2.maximumComponent(o)},O.multiply=function(e,t,n){var r=e[0]*t[0]+e[2]*t[1],a=e[0]*t[2]+e[2]*t[3],i=e[1]*t[0]+e[3]*t[1],u=e[1]*t[2]+e[3]*t[3];return n[0]=r,n[1]=i,n[2]=a,n[3]=u,n},O.add=function(e,t,n){return n[0]=e[0]+t[0],n[1]=e[1]+t[1],n[2]=e[2]+t[2],n[3]=e[3]+t[3],n},O.subtract=function(e,t,n){return n[0]=e[0]-t[0],n[1]=e[1]-t[1],n[2]=e[2]-t[2],n[3]=e[3]-t[3],n},O.multiplyByVector=function(e,t,n){var r=e[0]*t.x+e[2]*t.y,a=e[1]*t.x+e[3]*t.y;return n.x=r,n.y=a,n},O.multiplyByScalar=function(e,t,n){return n[0]=e[0]*t,n[1]=e[1]*t,n[2]=e[2]*t,n[3]=e[3]*t,n},O.multiplyByScale=function(e,t,n){return n[0]=e[0]*t.x,n[1]=e[1]*t.x,n[2]=e[2]*t.y,n[3]=e[3]*t.y,n},O.negate=function(e,t){return t[0]=-e[0],t[1]=-e[1],t[2]=-e[2],t[3]=-e[3],t},O.transpose=function(e,t){var n=e[0],r=e[2],a=e[1],i=e[3];return t[0]=n,t[1]=r,t[2]=a,t[3]=i,t},O.abs=function(e,t){return t[0]=Math.abs(e[0]),t[1]=Math.abs(e[1]),t[2]=Math.abs(e[2]),t[3]=Math.abs(e[3]),t},O.equals=function(e,t){return e===t||a.defined(e)&&a.defined(t)&&e[0]===t[0]&&e[1]===t[1]&&e[2]===t[2]&&e[3]===t[3]},O.equalsArray=function(e,t,n){return e[0]===t[n]&&e[1]===t[n+1]&&e[2]===t[n+2]&&e[3]===t[n+3]},O.equalsEpsilon=function(e,t,n){return e===t||a.defined(e)&&a.defined(t)&&Math.abs(e[0]-t[0])<=n&&Math.abs(e[1]-t[1])<=n&&Math.abs(e[2]-t[2])<=n&&Math.abs(e[3]-t[3])<=n},O.IDENTITY=a.freezeObject(new O(1,0,0,1)),O.ZERO=a.freezeObject(new O(0,0,0,0)),O.COLUMN0ROW0=0,O.COLUMN0ROW1=1,O.COLUMN1ROW0=2,O.COLUMN1ROW1=3,n.defineProperties(O.prototype,{length:{get:function(){return O.packedLength}}}),O.prototype.clone=function(e){return O.clone(this,e)},O.prototype.equals=function(e){return O.equals(this,e)},O.prototype.equalsEpsilon=function(e,t){return O.equalsEpsilon(this,e,t)},O.prototype.toString=function(){return"("+this[0]+", "+this[2]+")\n("+this[1]+", "+this[3]+")"};var s={POINTS:r.WebGLConstants.POINTS,LINES:r.WebGLConstants.LINES,LINE_LOOP:r.WebGLConstants.LINE_LOOP,LINE_STRIP:r.WebGLConstants.LINE_STRIP,TRIANGLES:r.WebGLConstants.TRIANGLES,TRIANGLE_STRIP:r.WebGLConstants.TRIANGLE_STRIP,TRIANGLE_FAN:r.WebGLConstants.TRIANGLE_FAN,validate:function(e){return e===s.POINTS||e===s.LINES||e===s.LINE_LOOP||e===s.LINE_STRIP||e===s.TRIANGLES||e===s.TRIANGLE_STRIP||e===s.TRIANGLE_FAN}},f=a.freezeObject(s);function c(e){e=a.defaultValue(e,a.defaultValue.EMPTY_OBJECT),this.attributes=e.attributes,this.indices=e.indices,this.primitiveType=a.defaultValue(e.primitiveType,f.TRIANGLES),this.boundingSphere=e.boundingSphere,this.geometryType=a.defaultValue(e.geometryType,i.NONE),this.boundingSphereCV=e.boundingSphereCV,this.offsetAttribute=e.offsetAttribute}c.computeNumberOfVertices=function(e){var t=-1;for(var n in e.attributes)if(e.attributes.hasOwnProperty(n)&&a.defined(e.attributes[n])&&a.defined(e.attributes[n].values)){var r=e.attributes[n];t=r.values.length/r.componentsPerAttribute}return t};var R=new v.Cartographic,P=new v.Cartesian3,V=new M.Matrix4,G=[new v.Cartographic,new v.Cartographic,new v.Cartographic],_=[new v.Cartesian2,new v.Cartesian2,new v.Cartesian2],W=[new v.Cartesian2,new v.Cartesian2,new v.Cartesian2],B=new v.Cartesian3,F=new M.Quaternion,k=new M.Matrix4,Y=new O;c._textureCoordinateRotationPoints=function(e,t,n,r){var a,i=v.Rectangle.center(r,R),u=v.Cartographic.toCartesian(i,n,P),o=M.Transforms.eastNorthUpToFixedFrame(u,n,V),s=M.Matrix4.inverse(o,V),f=_,c=G;c[0].longitude=r.west,c[0].latitude=r.south,c[1].longitude=r.west,c[1].latitude=r.north,c[2].longitude=r.east,c[2].latitude=r.south;var l=B;for(a=0;a<3;a++)v.Cartographic.toCartesian(c[a],n,l),l=M.Matrix4.multiplyByPointAsVector(s,l,l),f[a].x=l.x,f[a].y=l.y;var d=M.Quaternion.fromAxisAngle(v.Cartesian3.UNIT_Z,-t,F),y=M.Matrix3.fromQuaternion(d,k),m=e.length,p=Number.POSITIVE_INFINITY,h=Number.POSITIVE_INFINITY,N=Number.NEGATIVE_INFINITY,I=Number.NEGATIVE_INFINITY;for(a=0;a<m;a++)l=M.Matrix4.multiplyByPointAsVector(s,e[a],l),l=M.Matrix3.multiplyByVector(y,l,l),p=Math.min(p,l.x),h=Math.min(h,l.y),N=Math.max(N,l.x),I=Math.max(I,l.y);var C=O.fromRotation(t,Y),b=W;b[0].x=p,b[0].y=h,b[1].x=p,b[1].y=I,b[2].x=N,b[2].y=h;var T=f[0],E=f[2].x-T.x,x=f[1].y-T.y;for(a=0;a<3;a++){var L=b[a];O.multiplyByVector(C,L,L),L.x=(L.x-T.x)/E,L.y=(L.y-T.y)/x}var w=b[0],g=b[1],S=b[2],A=new Array(6);return v.Cartesian2.pack(w,A),v.Cartesian2.pack(g,A,2),v.Cartesian2.pack(S,A,4),A},e.Geometry=c,e.GeometryAttribute=function(e){e=a.defaultValue(e,a.defaultValue.EMPTY_OBJECT),this.componentDatatype=e.componentDatatype,this.componentsPerAttribute=e.componentsPerAttribute,this.normalize=a.defaultValue(e.normalize,!1),this.values=e.values},e.GeometryType=i,e.Matrix2=O,e.PrimitiveType=f});
