/**
 * Cesium - https://github.com/AnalyticalGraphicsInc/cesium
 *
 * Copyright 2011-2020 Cesium Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Columbus View (Pat. Pend.)
 *
 * Portions licensed separately.
 * See https://github.com/AnalyticalGraphicsInc/cesium/blob/master/LICENSE.md for full licensing details.
 */
define(["./when-0488ac89","./Check-78ca6843","./Math-8a4c9da1","./Cartesian2-cc1e6450","./defineProperties-c6a70625","./Transforms-fa4f10bc","./RuntimeError-4d6e0952","./WebGLConstants-66e14a3b","./ComponentDatatype-9252f28f","./AttributeCompression-fe1560e2","./IntersectionTests-12255a09","./Plane-466db411","./WebMercatorProjection-c0de4fbc","./createTaskProcessorWorker","./EllipsoidTangentPlane-70069c84","./OrientedBoundingBox-5e4e94f2","./TerrainEncoding-05a676fa"],function(We,e,Fe,Oe,t,Ye,ke,i,a,r,n,o,Ue,s,Ve,He,Le){"use strict";var De=Uint16Array.BYTES_PER_ELEMENT,Ge=Int32Array.BYTES_PER_ELEMENT,je=Uint32Array.BYTES_PER_ELEMENT,ze=Float32Array.BYTES_PER_ELEMENT,qe=Float64Array.BYTES_PER_ELEMENT;function Je(e,t,i){i=We.defaultValue(i,Fe.CesiumMath);for(var a=e.length,r=0;r<a;++r)if(i.equalsEpsilon(e[r],t,Fe.CesiumMath.EPSILON12))return r;return-1}var Ke=new Oe.Cartographic,Qe=new Oe.Cartesian3,Xe=new Oe.Cartesian3,Ze=new Oe.Cartesian3,$e=new Ye.Matrix4;function et(e,t,i,a,r,n,o,s,u,h){for(var c=o.length,d=0;d<c;++d){var g=o[d],l=g.cartographic,m=g.index,p=e.length,v=l.longitude,I=l.latitude;I=Fe.CesiumMath.clamp(I,-Fe.CesiumMath.PI_OVER_TWO,Fe.CesiumMath.PI_OVER_TWO);var f=l.height-n.skirtHeight;n.hMin=Math.min(n.hMin,f),Oe.Cartographic.fromRadians(v,I,f,Ke),u&&(Ke.longitude+=s),u?d===c-1?Ke.latitude+=h:0===d&&(Ke.latitude-=h):Ke.latitude+=s;var E=n.ellipsoid.cartographicToCartesian(Ke);e.push(E),t.push(f),i.push(Oe.Cartesian2.clone(i[m])),0<a.length&&a.push(a[m]),Ye.Matrix4.multiplyByPoint(n.toENU,E,Qe);var T=n.minimum,C=n.maximum;Oe.Cartesian3.minimumByComponent(Qe,T,T),Oe.Cartesian3.maximumByComponent(Qe,C,C);var M=n.lastBorderPoint;if(We.defined(M)){var N=M.index;r.push(N,p-1,p,p,m,N)}n.lastBorderPoint=g}}return s(function(e,t){e.ellipsoid=Oe.Ellipsoid.clone(e.ellipsoid),e.rectangle=Oe.Rectangle.clone(e.rectangle);var i=function(e,t,i,a,r,n,o,s,u,h){var c,d,g,l,m,p;p=We.defined(a)?(c=a.west,d=a.south,g=a.east,l=a.north,m=a.width,a.height):(c=Fe.CesiumMath.toRadians(r.west),d=Fe.CesiumMath.toRadians(r.south),g=Fe.CesiumMath.toRadians(r.east),l=Fe.CesiumMath.toRadians(r.north),m=Fe.CesiumMath.toRadians(a.width),Fe.CesiumMath.toRadians(a.height));var v,I,f=[d,l],E=[c,g],T=Ye.Transforms.eastNorthUpToFixedFrame(t,i),C=Ye.Matrix4.inverseTransformation(T,$e);s&&(v=Ue.WebMercatorProjection.geodeticLatitudeToMercatorAngle(d),I=1/(Ue.WebMercatorProjection.geodeticLatitudeToMercatorAngle(l)-v));var M=new DataView(e),N=Number.POSITIVE_INFINITY,x=Number.NEGATIVE_INFINITY,b=Xe;b.x=Number.POSITIVE_INFINITY,b.y=Number.POSITIVE_INFINITY,b.z=Number.POSITIVE_INFINITY;var S=Ze;S.x=Number.NEGATIVE_INFINITY,S.y=Number.NEGATIVE_INFINITY,S.z=Number.NEGATIVE_INFINITY;var P,w,B=0,y=0,A=0;for(w=0;w<4;++w){var R=B;P=M.getUint32(R,!0),R+=je;var _=Fe.CesiumMath.toRadians(180*M.getFloat64(R,!0));R+=qe,-1===Je(E,_)&&E.push(_);var W=Fe.CesiumMath.toRadians(180*M.getFloat64(R,!0));R+=qe,-1===Je(f,W)&&f.push(W),R+=2*qe;var F=M.getInt32(R,!0);R+=Ge,y+=F,F=M.getInt32(R,!0),A+=3*F,B+=P+je}var O=[],Y=[],k=new Array(y),U=new Array(y),V=new Array(y),H=s?new Array(y):[],L=new Array(A),D=[],G=[],j=[],z=[],q=0,J=0;for(w=B=0;w<4;++w){P=M.getUint32(B,!0);var K=B+=je,Q=Fe.CesiumMath.toRadians(180*M.getFloat64(B,!0));B+=qe;var X=Fe.CesiumMath.toRadians(180*M.getFloat64(B,!0));B+=qe;var Z=Fe.CesiumMath.toRadians(180*M.getFloat64(B,!0)),$=.5*Z;B+=qe;var ee=Fe.CesiumMath.toRadians(180*M.getFloat64(B,!0)),te=.5*ee;B+=qe;var ie=M.getInt32(B,!0);B+=Ge;var ae=M.getInt32(B,!0);B+=Ge,B+=Ge;for(var re=new Array(ie),ne=0;ne<ie;++ne){var oe=Q+M.getUint8(B++)*Z;Ke.longitude=oe;var se=X+M.getUint8(B++)*ee;Ke.latitude=se;var ue=M.getFloat32(B,!0);if(B+=ze,0!==ue&&ue<h&&(ue*=-Math.pow(2,u)),ue*=6371010*n,Ke.height=ue,-1!==Je(E,oe)||-1!==Je(f,se)){var he=Je(O,Ke,Oe.Cartographic);if(-1!==he){re[ne]=Y[he];continue}O.push(Oe.Cartographic.clone(Ke)),Y.push(q)}re[ne]=q,Math.abs(oe-c)<$?D.push({index:q,cartographic:Oe.Cartographic.clone(Ke)}):Math.abs(oe-g)<$?j.push({index:q,cartographic:Oe.Cartographic.clone(Ke)}):Math.abs(se-d)<te?G.push({index:q,cartographic:Oe.Cartographic.clone(Ke)}):Math.abs(se-l)<te&&z.push({index:q,cartographic:Oe.Cartographic.clone(Ke)}),N=Math.min(ue,N),x=Math.max(ue,x),V[q]=ue;var ce=i.cartographicToCartesian(Ke);k[q]=ce,s&&(H[q]=(Ue.WebMercatorProjection.geodeticLatitudeToMercatorAngle(se)-v)*I),Ye.Matrix4.multiplyByPoint(C,ce,Qe),Oe.Cartesian3.minimumByComponent(Qe,b,b),Oe.Cartesian3.maximumByComponent(Qe,S,S);var de=(oe-c)/(g-c);de=Fe.CesiumMath.clamp(de,0,1);var ge=(se-d)/(l-d);ge=Fe.CesiumMath.clamp(ge,0,1),U[q]=new Oe.Cartesian2(de,ge),++q}for(var le=3*ae,me=0;me<le;++me,++J)L[J]=re[M.getUint16(B,!0)],B+=De;if(P!==B-K)throw new ke.RuntimeError("Invalid terrain tile.")}k.length=q,U.length=q,V.length=q,s&&(H.length=q);var pe=q,ve=J,Ie={hMin:N,lastBorderPoint:void 0,skirtHeight:o,toENU:C,ellipsoid:i,minimum:b,maximum:S};D.sort(function(e,t){return t.cartographic.latitude-e.cartographic.latitude}),G.sort(function(e,t){return e.cartographic.longitude-t.cartographic.longitude}),j.sort(function(e,t){return e.cartographic.latitude-t.cartographic.latitude}),z.sort(function(e,t){return t.cartographic.longitude-e.cartographic.longitude});var fe=1e-5;if(et(k,V,U,H,L,Ie,D,-fe*m,!0,-fe*p),et(k,V,U,H,L,Ie,G,-fe*p,!1),et(k,V,U,H,L,Ie,j,fe*m,!0,fe*p),et(k,V,U,H,L,Ie,z,fe*p,!1),0<D.length&&0<z.length){var Ee=D[0].index,Te=z[z.length-1].index,Ce=k.length-1;L.push(Te,Ce,pe,pe,Ee,Te)}y=k.length;var Me,Ne=Ye.BoundingSphere.fromPoints(k);We.defined(a)&&(Me=He.OrientedBoundingBox.fromRectangle(a,N,x,i));for(var xe=new Le.EllipsoidalOccluder(i).computeHorizonCullingPointPossiblyUnderEllipsoid(t,k,N),be=new Ve.AxisAlignedBoundingBox(b,S,t),Se=new Le.TerrainEncoding(be,Ie.hMin,x,T,!1,s),Pe=new Float32Array(y*Se.getStride()),we=0,Be=0;Be<y;++Be)we=Se.encode(Pe,we,k[Be],U[Be],V[Be],void 0,H[Be]);var ye=D.map(function(e){return e.index}).reverse(),Ae=G.map(function(e){return e.index}).reverse(),Re=j.map(function(e){return e.index}).reverse(),_e=z.map(function(e){return e.index}).reverse();return Ae.unshift(Re[Re.length-1]),Ae.push(ye[0]),_e.unshift(ye[ye.length-1]),_e.push(Re[0]),{vertices:Pe,indices:new Uint16Array(L),maximumHeight:x,minimumHeight:N,encoding:Se,boundingSphere3D:Ne,orientedBoundingBox:Me,occludeePointInScaledSpace:xe,vertexCountWithoutSkirts:pe,indexCountWithoutSkirts:ve,westIndicesSouthToNorth:ye,southIndicesEastToWest:Ae,eastIndicesNorthToSouth:Re,northIndicesWestToEast:_e}}(e.buffer,e.relativeToCenter,e.ellipsoid,e.rectangle,e.nativeRectangle,e.exaggeration,e.skirtHeight,e.includeWebMercatorT,e.negativeAltitudeExponentBias,e.negativeElevationThreshold),a=i.vertices;t.push(a.buffer);var r=i.indices;return t.push(r.buffer),{vertices:a.buffer,indices:r.buffer,numberOfAttributes:i.encoding.getStride(),minimumHeight:i.minimumHeight,maximumHeight:i.maximumHeight,boundingSphere3D:i.boundingSphere3D,orientedBoundingBox:i.orientedBoundingBox,occludeePointInScaledSpace:i.occludeePointInScaledSpace,encoding:i.encoding,vertexCountWithoutSkirts:i.vertexCountWithoutSkirts,indexCountWithoutSkirts:i.indexCountWithoutSkirts,westIndicesSouthToNorth:i.westIndicesSouthToNorth,southIndicesEastToWest:i.southIndicesEastToWest,eastIndicesNorthToSouth:i.eastIndicesNorthToSouth,northIndicesWestToEast:i.northIndicesWestToEast}})});
